Index: branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/MinorDefaultRule.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/MinorDefaultRule.cs	(revision 9605)
+++ branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/DefaultRule/MinorDefaultRule.cs	(revision 9605)
@@ -0,0 +1,76 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization.Operators.LCS.DefaultRule {
+  [Item("MinorDefaultRule", "Description missing")]
+  [StorableClass]
+  public class MinorDefaultRule : DefaultRuleOperator, IStochasticOperator {
+
+    #region Parameter Properties
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected MinorDefaultRule(bool deserializing) : base(deserializing) { }
+    protected MinorDefaultRule(MinorDefaultRule original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public MinorDefaultRule()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random"));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MinorDefaultRule(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      if (NichingParameter.ActualValue == null) {
+        NichingParameter.ActualValue = new BoolValue(false);
+        NichesParameter.ActualValue = new IntValue(1);
+        var problemData = GAssistNichesProblemDataParameter.ActualValue;
+        var trainingIndices = problemData.TrainingIndices;
+        var actions = problemData.FetchAction(trainingIndices);
+
+        Dictionary<IGAssistNiche, int> classCount = new Dictionary<IGAssistNiche, int>(actions.First().Comparer);
+        foreach (var niche in GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches()) {
+          classCount[niche] = 0;
+        }
+        foreach (var action in actions) {
+          classCount[action] += 1;
+        }
+        var minAction = classCount.MinItems(x => x.Value).ToList();
+        var index = RandomParameter.ActualValue.Next(0, minAction.Count);
+        DefaultClassParameter.ActualValue = minAction[index].Key;
+      }
+      return base.Apply();
+    }
+  }
+}
Index: branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistIndividual.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistIndividual.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistIndividual.cs	(revision 9605)
@@ -25,6 +25,6 @@
 namespace HeuristicLab.Optimization.Operators.LCS {
   public interface IGAssistIndividual : IGAssistModel {
+    double Length { get; }
     IGAssistNiche Niche { get; }
-    void SetNiche(IRandom random, IGAssistNiche niche);
     void ApplySplit(IRandom random, double probability);
     void ApplyMerge(IRandom random, double probability);
Index: branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistObjectiveEvaluator.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistObjectiveEvaluator.cs	(revision 9605)
+++ branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistObjectiveEvaluator.cs	(revision 9605)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization.Operators.LCS.Selection;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  public interface IGAssistObjectiveEvaluator : IHierarchicalSingleObjectiveEvaluator {
+    ILookupParameter<ItemList<ItemList<IntValue>>> StrataParameter { get; }
+    IValueLookupParameter<BoolValue> MaximizationParameter { get; }
+  }
+}
Index: branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistProblem.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistProblem.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistProblem.cs	(revision 9605)
@@ -24,5 +24,5 @@
 namespace HeuristicLab.Optimization.Operators.LCS {
   public interface IGAssistProblem : ISingleObjectiveHeuristicOptimizationProblem, IDataAnalysisProblem {
-    new IStrataSingleObjectiveEvaluator Evaluator { get; }
+    new IGAssistObjectiveEvaluator Evaluator { get; }
     string NichingParameterName { get; }
   }
Index: branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistSolutionCreator.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistSolutionCreator.cs	(revision 9605)
+++ branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistSolutionCreator.cs	(revision 9605)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  public interface IGAssistSolutionCreator : IOperator {
+    IValueLookupParameter<ItemCollection<IDiscretizer>> DiscretizersParameter { get; }
+    ILookupParameter<IGAssistNiche> GAssistNicheParameter { get; }
+  }
+}
Index: branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/NicheSolutionCreator.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/NicheSolutionCreator.cs	(revision 9605)
+++ branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/NicheSolutionCreator.cs	(revision 9605)
@@ -0,0 +1,138 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  /// <summary>
+  /// An operator which creates new solutions. Evaluation of the new solutions is executed in parallel, if an engine is used which supports parallelization.
+  /// </summary>
+  [Item("NicheSolutionCreator", "")]
+  [StorableClass]
+  public sealed class NicheSolutionCreator : SingleSuccessorOperator {
+    private const string INITIALNICHEPARAMETERNAME = "InitialNiche";
+
+    public ValueLookupParameter<IntValue> NumberOfSolutionsParameter {
+      get { return (ValueLookupParameter<IntValue>)Parameters["NumberOfSolutions"]; }
+    }
+    public ValueLookupParameter<IGAssistSolutionCreator> SolutionCreatorParameter {
+      get { return (ValueLookupParameter<IGAssistSolutionCreator>)Parameters["SolutionCreator"]; }
+    }
+    public ValueLookupParameter<IOperator> EvaluatorParameter {
+      get { return (ValueLookupParameter<IOperator>)Parameters["Evaluator"]; }
+    }
+    public ValueLookupParameter<BoolValue> ParallelParameter {
+      get { return (ValueLookupParameter<BoolValue>)Parameters["Parallel"]; }
+    }
+    public IValueLookupParameter<BoolValue> NichingParameter {
+      get { return (IValueLookupParameter<BoolValue>)Parameters["Niching"]; }
+    }
+    public ILookupParameter<IGAssistProblemData> GAssistNichesProblemDataParameter {
+      get { return (ILookupParameter<IGAssistProblemData>)Parameters["GAssistNichesProblemData"]; }
+    }
+    public ILookupParameter<IGAssistNiche> DefaultClassParameter {
+      get { return (ILookupParameter<IGAssistNiche>)Parameters["DefaultClass"]; }
+    }
+    private ScopeParameter CurrentScopeParameter {
+      get { return (ScopeParameter)Parameters["CurrentScope"]; }
+    }
+    public IScope CurrentScope {
+      get { return CurrentScopeParameter.ActualValue; }
+    }
+    public IntValue NumberOfSolutions {
+      get { return NumberOfSolutionsParameter.Value; }
+      set { NumberOfSolutionsParameter.Value = value; }
+    }
+
+    [StorableConstructor]
+    private NicheSolutionCreator(bool deserializing) : base(deserializing) { }
+    private NicheSolutionCreator(NicheSolutionCreator original, Cloner cloner) : base(original, cloner) { }
+    public NicheSolutionCreator()
+      : base() {
+      Parameters.Add(new ValueLookupParameter<IntValue>("NumberOfSolutions", "The number of solutions that should be created."));
+      Parameters.Add(new ValueLookupParameter<IGAssistSolutionCreator>("SolutionCreator", "The operator which is used to create new solutions."));
+      Parameters.Add(new ValueLookupParameter<IOperator>("Evaluator", "The operator which is used to evaluate new solutions. This operator is executed in parallel, if an engine is used which supports parallelization."));
+      Parameters.Add(new ValueLookupParameter<BoolValue>("Parallel", "True if the operator should be applied in parallel on all sub-scopes, otherwise false.", new BoolValue(true)));
+      Parameters.Add(new ScopeParameter("CurrentScope", "The current scope to which the new solutions are added as sub-scopes."));
+      Parameters.Add(new ValueLookupParameter<BoolValue>("Niching", ""));
+      Parameters.Add(new LookupParameter<IGAssistProblemData>("GAssistNichesProblemData", ""));
+      Parameters.Add(new LookupParameter<IGAssistNiche>("DefaultClass"));
+    }
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      if (!Parameters.ContainsKey("Parallel")) Parameters.Add(new ValueLookupParameter<BoolValue>("Parallel", "True if the operator should be applied in parallel on all sub-scopes, otherwise false.", new BoolValue(true))); // backwards compatibility
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new NicheSolutionCreator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      int count = NumberOfSolutionsParameter.ActualValue.Value;
+      var creator = SolutionCreatorParameter.ActualValue;
+      var evaluator = EvaluatorParameter.ActualValue;
+      bool parallel = ParallelParameter.ActualValue.Value;
+
+      int current = CurrentScope.SubScopes.Count;
+      for (int i = 0; i < count; i++)
+        CurrentScope.SubScopes.Add(new Scope((current + i).ToString()));
+
+      OperationCollection niche = new OperationCollection();
+      OperationCollection creation = new OperationCollection();
+      OperationCollection evaluation = new OperationCollection() { Parallel = parallel };
+      var vcList = new List<VariableCreator>();
+      if (DefaultClassParameter.ActualValue != null) {
+        //default rule has been set beforehand
+        var vc = new VariableCreator();
+        vc.CollectedValues.Add(new ValueParameter<IGAssistNiche>(INITIALNICHEPARAMETERNAME, DefaultClassParameter.ActualValue));
+        vcList.Add(vc);
+      } else {
+        //default rule is set to auto
+        foreach (var curNiche in GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches()) {
+          var vc = new VariableCreator();
+          vc.CollectedValues.Add(new ValueParameter<IGAssistNiche>(INITIALNICHEPARAMETERNAME, curNiche));
+          vcList.Add(vc);
+        }
+      }
+      creator.GAssistNicheParameter.ActualName = INITIALNICHEPARAMETERNAME;
+      for (int i = 0; i < count; i++) {
+        //only if niching is disabled and no default class has been set, then no niche has to be created in the scope
+        if (NichingParameter.ActualValue.Value || DefaultClassParameter.ActualValue != null) {
+          niche.Add(ExecutionContext.CreateOperation(vcList[i % vcList.Count], CurrentScope.SubScopes[current + i]));
+        }
+        if (creator != null) creation.Add(ExecutionContext.CreateOperation(creator, CurrentScope.SubScopes[current + i]));
+        if (evaluator != null) evaluation.Add(ExecutionContext.CreateOperation(evaluator, CurrentScope.SubScopes[current + i]));
+      }
+      OperationCollection next = new OperationCollection();
+      next.Add(niche);
+      next.Add(creation);
+      next.Add(evaluation);
+      next.Add(base.Apply());
+      return next;
+    }
+  }
+}
Index: branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/HeuristicLab.Optimization.Operators.LCS-3.3.csproj
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/HeuristicLab.Optimization.Operators.LCS-3.3.csproj	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/HeuristicLab.Optimization.Operators.LCS-3.3.csproj	(revision 9605)
@@ -92,5 +92,5 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="DefaultRule\AutoDefaultRule.cs" />
+    <Compile Include="GAssist\DefaultRule\AutoDefaultRule.cs" />
     <Compile Include="Discretizer\InitializeDiscretizersOperator.cs" />
     <Compile Include="GAssist\GAssistNicheComparer.cs" />
@@ -100,9 +100,9 @@
     <Compile Include="GAssist\Interfaces\IGAssistEnsembleProblemData.cs" />
     <Compile Include="GAssist\Interfaces\IGAssistProblemData.cs" />
-    <Compile Include="DefaultRule\MajorDefaultRule.cs" />
-    <Compile Include="DefaultRule\DefaultRuleOperator.cs" />
-    <Compile Include="DefaultRule\DisabledDefaultRule.cs" />
-    <Compile Include="DefaultRule\IDefaultRuleOperator.cs" />
-    <Compile Include="DefaultRule\MinorDefaultRule.cs" />
+    <Compile Include="GAssist\DefaultRule\MajorDefaultRule.cs" />
+    <Compile Include="GAssist\DefaultRule\DefaultRuleOperator.cs" />
+    <Compile Include="GAssist\DefaultRule\DisabledDefaultRule.cs" />
+    <Compile Include="GAssist\DefaultRule\IDefaultRuleOperator.cs" />
+    <Compile Include="GAssist\DefaultRule\MinorDefaultRule.cs" />
     <Compile Include="Discretizer\UniformWidthDiscretizer.cs" />
     <Compile Include="Discretizer\IDiscretizer.cs" />
@@ -112,5 +112,4 @@
     <Compile Include="GAssist\Interfaces\IGAssistEnsembleSolution.cs" />
     <Compile Include="GAssist\Interfaces\IGAssistIndividual.cs" />
-    <Compile Include="GAssist\Interfaces\IGAssistIndividualCreator.cs" />
     <Compile Include="GAssist\Interfaces\IGAssistInput.cs" />
     <Compile Include="GAssist\Interfaces\IGAssistModel.cs" />
@@ -118,9 +117,11 @@
     <Compile Include="GAssist\Interfaces\IGAssistNicheEqualityComparer.cs" />
     <Compile Include="GAssist\Interfaces\IGAssistSolution.cs" />
+    <Compile Include="GAssist\Interfaces\IGAssistSolutionCreator.cs" />
     <Compile Include="GAssist\Interfaces\IGAssistSpecialStage.cs" />
-    <Compile Include="GAssist\Interfaces\IStrataSingleObjectiveEvaluator.cs" />
+    <Compile Include="GAssist\Interfaces\IGAssistObjectiveEvaluator.cs" />
     <Compile Include="GAssist\MDL\IMDLCalculatorBasedOperator.cs" />
     <Compile Include="GAssist\MDL\MDLCalculator.cs" />
     <Compile Include="GAssist\MDL\MDLIterationOperator.cs" />
+    <Compile Include="GAssist\NicheSolutionCreator.cs" />
     <Compile Include="GAssist\SpecialStage\GAssistSpecialStageMultiOperator.cs" />
     <Compile Include="GAssist\SpecialStage\GAssistSpecialStageOperator.cs" />
@@ -129,4 +130,6 @@
     <Compile Include="GAssist\SpecialStage\SplitOperator.cs" />
     <Compile Include="Plugin.cs" />
+    <Compile Include="Selection\IHierarchicalSingleObjectiveEvaluator.cs" />
+    <Compile Include="Selection\IHierarchicalSingleObjectiveSelector.cs" />
     <Compile Include="Selection\INichingSingleObjectiveSelector.cs" />
     <Compile Include="Selection\NichingTournamentSelector.cs" />
Index: branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Plugin.cs.frame
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Plugin.cs.frame	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Plugin.cs.frame	(revision 9605)
@@ -25,6 +25,15 @@
   [Plugin("HeuristicLab.Optimization.Operators.LCS", "3.3.7.$WCREV$")]
   [PluginFile("HeuristicLab.Optimization.Operators.LCS-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
   [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.DataAnalysis", "3.4")]
+  [PluginDependency("HeuristicLab.Selection", "3.3")]
   public class HeuristicLabOptimizationOperatorsLCSPlugin : PluginBase {
   }
Index: branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Selection/IHierarchicalSingleObjectiveEvaluator.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Selection/IHierarchicalSingleObjectiveEvaluator.cs	(revision 9605)
+++ branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Selection/IHierarchicalSingleObjectiveEvaluator.cs	(revision 9605)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Optimization.Operators.LCS.Selection {
+  public interface IHierarchicalSingleObjectiveEvaluator : ISingleObjectiveEvaluator {
+    ILookupParameter<DoubleValue> LengthParameter { get; }
+  }
+}
Index: branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Selection/IHierarchicalSingleObjectiveSelector.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Selection/IHierarchicalSingleObjectiveSelector.cs	(revision 9605)
+++ branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Selection/IHierarchicalSingleObjectiveSelector.cs	(revision 9605)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  public interface IHierarchicalSingleObjectiveSelector : ISingleObjectiveSelector, IIterationBasedOperator {
+    ILookupParameter<ItemArray<DoubleValue>> LengthParameter { get; }
+    IValueLookupParameter<DoubleValue> LengthThresholdParameter { get; }
+    IValueLookupParameter<IntValue> IterationHirachicalSelectionParameter { get; }
+  }
+}
